//SeitenZahlenText_ss_504d.js
// 06.04.2018 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Wandelt die Seitennummern in ausgeschriebene Textketten um

// vorbeugenderweise das Anzeigen von Dialogen aktivieren //////////////////////////
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist ////////////////////////////////////////////
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}
else {
	curDoc = app.documents[0];
}

// prfen, ob eventuelle Abschnitts-Prfizes in den Seitennummern enthalten sind
var allSections = curDoc.sections;
var nSections   = allSections.length;
for (var s=0; s<nSections; s++) {
	if (allSections[s].includeSectionPrefix) {
		alert ("Das Abschnitts-Prfix darf nicht sichtbar sein.", "Stop");
		exit();
	}
}

// die Arrays mit den Teil-Strings /////////////////////////////////////////////////
oneStrings = ["null", "ein", "zwei", "drei", "vier", "fnf", "sechs", "sieben", "acht", "neun"];
dblStrings = ["", "", "", "", "", "", "", "", "", "", "zehn", "elf", "zwlf", "dreizehn", "vierzehn", "fnfzehn", "sechzehn", "siebzehn", "achtzehn", "neunzehn"];
tenStrings = ["", "zehn", "zwanzig", "dreissig", "vierzig", "fnfzig", "sechzig", "siebzig", "achtzig", "neunzig"];

// die Suchen/Ersetzen-Preferences lschen /////////////////////////////////////////
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findTextPreferences = app.changeTextPreferences = null;

// die Suchen-Strings vorbereiten //////////////////////////////////////////////////
app.findGrepPreferences.findWhat = "[0-9]+";
app.findTextPreferences.findWhat = "\u0018"; // = SpecialCharacters.AUTO_PAGE_NUMBER

// den Array der Textrahmen initialisieren
var txtFrameArr = [];

// die Auswahl speichern und prfen
var nTxtFrames = 0;
curSel = app.selection;
if (curSel.length > 0) {
	for (var s=0; s<curSel.length; s++) {
		var curType = curSel[s].constructor.name;
		if (curType == "TextFrame") {
			txtFrameArr.push(curSel[s]);
		}
		else if (curType == "Group") {
			var allItems = curSel[s].allPageItems;
			for (var n=0; n<allItems.length; n++) {
				var curType = allItems[n].constructor.name;
				if (curType == "TextFrame") {
					txtFrameArr.push(allItems[n]);
				}
			}
		}
		else {
			if (curSel[0].hasOwnProperty("baseline")) {
				txtFrameArr.push(curSel[0].parentTextFrames[0]);
			}
		}
	}
	nTxtFrames = txtFrameArr.length;
	if (nTxtFrames == 0) {
		alert ("Die Auswahl enthlt keinen Textrahmen.", "Stop");
		app.findGrepPreferences = app.changeGrepPreferences = null;
		app.findTextPreferences = app.changeTextPreferences = null;
		exit();
	}
}

// das Ergebnis prfen /////////////////////////////////////////////////////////////
if (nTxtFrames == 0) { // wenn keine Auswahl, die Funktion aufrufen
	// drei Variablen initialisieren /////////////////////////////////////////////////
	var allPages = curDoc.pages;
	var nPages   = allPages.length;
	var nSpreads = curDoc.masterSpreads.length;
	var firstMaster = curDoc.pages[0].appliedMaster;
	// die Anzahl zugewiesener Mustervorlagen
	if (nSpreads > 1) {
		var moreThanOne = false;
		for (var n=1; n<nPages; n++) {
			if (curDoc.pages[n].appliedMaster != firstMaster) {
				moreThanOne = true;
				break;
			}
		}
		if (!moreThanOne) {
			nSpreads = 1;
		}
	}
	// die Funktion aufrufen
	getNotSel(allPages, nPages, nSpreads, firstMaster);
}
else { // sonst die Rahmen der Auswahl behandeln
	for (tF=0; tF<nTxtFrames; tF++) {
		var curFrame = txtFrameArr[tF];
		var curCont  = curFrame.texts[0].contents;
		if (curCont.indexOf("\u0018") != -1) {
			pageName = curFrame.parentPage.name;
			var numberText = getNumberText(pageName);
			// wenn die Textkette nicht undefiniert ist ...
			if (numberText != undefined) {
				if (curCont[0] == "\u0018") {
					var defString = (numberText[0].toUpperCase()) + numberText.slice(1);
				}
				else {
					var defString = numberText;
				}
				app.changeTextPreferences.changeTo = defString;
				curFrame.changeText();
			}
		}
		else {
			try {
				var oneNum = curFrame.texts[0].findGrep();
				var numCnt = oneNum[0].contents;
				var numberText = getNumberText(numCnt);
				if (numberText != undefined) {
					app.changeGrepPreferences.changeTo = numberText;
					oneNum[0].changeGrep();
				}
			}
			catch (e) {
			}
		}
	}
}

// die Suchen/Ersetzen-Preferences zurcksetzen ////////////////////////////////////
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findTextPreferences = app.changeTextPreferences = null;

// das Ende der Aktion verknden ///////////////////////////////////////////////////
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


////////////////////////////////////////////////////////////////////////////////////
// die Vorkommen finden ////////////////////////////////////////////////////////////
function getNotSel(allPages, nPages, nSpreads, firstMaster) {
	var allNumbers = curDoc.findText();
	var nNumbers   = allNumbers.length;
	// wenn keine gelsten Rahmen mit Seitenzahlen ...
	if (nNumbers == 0) {
		// zwei Variablen initialisieren
		var pageNumberFrameL = "";
		var pageNumberFrameR = "";
		// die Musterseitenobjekte (wenn nur _eine_ Mustervorlage)
		if (nSpreads == 1) {
			var sPages = firstMaster.pages.length;
			var allGroups = firstMaster.groups;
			var nGroups   = allGroups.length;
			// eventuelle Gruppen auflsen
			for (g=nGroups-1; g>-1; g--) {
				try {
					allGroups[g].ungroup();
				}
				catch (e) {
				}
			}
			var txtFramesL = firstMaster.pages[0].textFrames;
			var nFrames    = txtFramesL.length;
			for (var n=0; n<nFrames; n++) {
				var numFrame = txtFramesL[n];
				var curCont = numFrame.texts[0].contents;
				if (curCont.indexOf("\u0018") != -1) {
					var pageNumberFrameL = txtFramesL[n];
					break;
				}
			}
			if (sPages == 2) {
				txtFramesR = firstMaster.pages[1].textFrames;
				nFrames    = txtFramesR.length;
				for (var n=0; n<nFrames; n++) {
					var numFrame = txtFramesR[n];
					var curCont = numFrame.texts[0].contents;
					if (curCont.indexOf("\u0018") != -1) {
						var pageNumberFrameR = txtFramesR[n];
						break;
					}
				}
			}
		}
		// eine Schleife durch die Seiten, die Rahmen mit den automatischen Seitenzahlen bergehen
		// und die Seitennummer durch den entsprechenden String ersetzen
		for (var p=0; p<nPages; p++) {
			// der Name der Seite
			var pNbr = (allPages[p].name);
			// die Funktion aufrufen, welche den Text der Nummer zusammensetzt
			var numberText = getNumberText(pNbr);
			// wenn die Textkette nicht undefiniert ist ...
			if (numberText != undefined) {
				// der Variablen den Rahmen auf der linken oder rechten Seite zuweisen
				if (pNbr % 2 == 0 || sPages == 1) {
					var pageNumberFrame = pageNumberFrameL;
				}
				else {
					var pageNumberFrame = pageNumberFrameR;
				}
				try { // versuchen, den Textrahmen zu bergehen und die Textkette einzusetzen
					var curFrame = pageNumberFrame.override(allPages[p]);
					var curCont = curFrame.texts[0].contents;
					if (curCont[0] == "\u0018") {
						var defString = (numberText[0].toUpperCase()) + numberText.slice(1);
					}
					else {
						var defString = numberText;
					}
					app.changeTextPreferences.changeTo = defString;
					curFrame.changeText();
				}
				catch (e) {
				}
			}
		}
	}
	else { // sonst nur die Seitenzahlen, welche auf Dokumentseiten greifbar sind
		for (var n=0; n<nNumbers; n++) {
			var curInfo  = getInfo(allNumbers[n]);
			var curFrame = curInfo[0];
			var curNbr   = curInfo[1];
			// die Funktion aufrufen, welche den Text der Nummer zusammensetzt
			var numberText = getNumberText(curNbr);
			// wenn die Textkette nicht undefiniert ist ...
			if (numberText != undefined) {
				var curCont = curFrame.texts[0].contents;
				if (curCont[0] == "\u0018") {
					var defString = (numberText[0].toUpperCase()) + numberText.slice(1);
				}
				else {
					var defString = numberText;
				}
				app.changeTextPreferences.changeTo = defString;
				curFrame.changeText();
			}
		}
	}
	
	// wenn keine gelsten Textrahmen und wenn mehr als eine Mustervorlage vorhanden ist
	if (nNumbers == 0 && nSpreads > 1) {
		// eine Schleife durch die Seiten, die Rahmen mit den automatischen Seitenzahlen bergehen
		// und die Seitennummer durch den entsprechenden String ersetzen
		for (var p=0; p<nPages; p++) {
			var makeCap = true;
			// die Mustervorlage herausfinden
			var actMaster = allPages[p].appliedMaster;
			// der Name der Seite
			var pNbr = (allPages[p].name);
			// die Funktion aufrufen, welche den Text der Nummer zusammensetzt
			var numberText = getNumberText(pNbr);
			// wenn die Textkette nicht undefiniert ist ...
			if (numberText != undefined) {
				var allGroups = actMaster.groups;
				var nGroups   = allGroups.length;
				// eventuelle Gruppen auflsen
				for (g=nGroups-1; g>-1; g--) {
					try {
						allGroups[g].ungroup();
					}
					catch (e) {
					}
				}
				var sPages = actMaster.pages.length;
				// der Variablen den Rahmen auf der linken oder rechten Seite zuweisen
				if (pNbr % 2 == 0 || sPages == 1) {
					var txtFramesL = actMaster.pages[0].textFrames;
					var nFrames    = txtFramesL.length;
					for (var n=0; n<nFrames; n++) {
						var numFrame = txtFramesL[n];
						try {
							var curCont = numFrame.texts[0].contents;
							if (curCont.indexOf("\u0018") != -1) {
								if (curCont[0] != "\u0018") {
									makeCap = false;
								}
								var pageNumberFrame = txtFramesL[n];
								break;
							}
						}
						catch (e) {
						}
					}
				}
				else {
					var txtFramesR = actMaster.pages[1].textFrames;
					var nFrames    = txtFramesR.length;
					for (var n=0; n<nFrames; n++) {
						var numFrame = txtFramesR[n];
						var curCont = numFrame.texts[0].contents;
						if (curCont.indexOf("\u0018") != -1) {
							if (curCont[0] != "\u0018") {
								makeCap = false;
							}
							var pageNumberFrame = txtFramesR[n];
							break;
						}
					}
				}
				try { // versuchen, den Textrahmen zu bergehen und die Textkette einzusetzen
					var curFrame = pageNumberFrame.override(allPages[p]);
					var curCont  = curFrame.texts[0].contents;
					if (makeCap) {
						var defString = (numberText[0].toUpperCase()) + numberText.slice(1);
					}
					else {
						var defString = numberText;
					}
					app.changeTextPreferences.changeTo = defString;
					curFrame.changeText();
				}
				catch (e) {
				}
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////
// die Seitennummer holen //////////////////////////////////////////////////////////
function getInfo(curNum) {
	var pageName = -1;
	try {
		curFrame = curNum.parent.textContainers[0];
		pageName = curFrame.parentPage.name;
	}
	catch (e) {
	}
	return [curFrame, pageName];	
}

////////////////////////////////////////////////////////////////////////////////////
// die Funktion, welche die Zahlen in Textketten umwandelt /////////////////////////
function getNumberText(pNbr) {
	if (isNaN(pNbr)) {
		alert ("Das Script funktioniert nur mit arabischen Ziffern.", "Achtung");
		app.findGrepPreferences = app.changeGrepPreferences = null;
		app.findTextPreferences = app.changeTextPreferences = null;
		exit();
	}
	var strLen = pNbr.length;
	var numVal = pNbr*1;
	if (strLen == 1) {
		if (numVal == 1) {
			return "eins";
		}
		else {
			return (oneStrings[numVal]);
		}
	}
	else if (strLen == 2) {
		if (numVal < 20) {
			return (dblStrings[numVal]);
		}
		else if (numVal > 19) {
			if (pNbr[1] == "0") {
				return (tenStrings[pNbr[0]]);
			}
			else {
				return (oneStrings[pNbr[1]]+"und"+tenStrings[pNbr[0]]);
			}
		}
	}
	else if (strLen == 3) {
		var d1 = pNbr[0];
		var d2 = pNbr[1];
		var d3 = pNbr[2];
		if (d2 == 0 && d3 == 0) { // 100
			return (oneStrings[d1]+"hundert");
		}
		else	if (d2 == 0 && d3 == 1) { // 101 {
			return (oneStrings[d1]+"hunderteins");
		}
		else if (d2 == 0 && d3 > 1) { // 102, etc.
			return (oneStrings[d1]+"hundert"+oneStrings[d3]);
		}
		else if (d2 > 0 && d3 == 0) { // 110, etc.
			return (oneStrings[d1]+"hundert"+tenStrings[d2]);
		}
		else if (d2 == 1 && d3 > 0) { // 111, etc.
			return (oneStrings[d1]+"hundert"+dblStrings[(d2+d3)]);
		}
		else if (d2 > 1 && d3 > 0) { // 121, etc.
			return (oneStrings[d1]+"hundert"+oneStrings[d3]+"und"+tenStrings[d2]);
		}
	}
	else if (strLen == 4) {
		var d1 = pNbr[0];
		var d2 = pNbr[1];
		var d3 = pNbr[2];
		var d4 = pNbr[3];
		if (d2 == 0 && d3 == 0 && d4 == 0) { // 1000
			return (oneStrings[d1]+"tausend");
		}
		else if (d2 == 0 && d3 == 0 && d4 == 1) { // 1001
			return (oneStrings[d1]+"tausendeins");
		}
		else if (d2 == 0 && d3 == 0 && d4 > 1) { // 1002, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d4]);
		}
		else if (d2 == 0 && d3 > 0 && d4 == 0) { // 1010, etc.
			return (oneStrings[d1]+"tausend"+tenStrings[d3]);
		}
		else if (d2 == 0 && d3 == 1 && d4 > 0) { // 1011, etc.
			return (oneStrings[d1]+"tausend"+dblStrings[d3+d4]);
		}
		else if (d2 == 0 && d3 > 1 && d4 > 0) { // 1021, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d4]+"und"+tenStrings[d3]);
		}
		else if (d2 > 0 && d3 == 0 && d4 == 0) { // 1100, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hundert");
		}
		else if (d2 > 0 && d3 == 0 && d4 == 1) { // 1101, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hunderteins");
		}
		else if (d2 > 0 && d3 == 0 && d4 > 1) { // 1102, etc. 
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hundert"+oneStrings[d4]);
		}
		else if (d2 > 0 && d3 > 0 && d4 == 0) { // 1110, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hundert"+tenStrings[d3]);
		}
		else if (d2 > 0 && d3 == 1 && d4 > 0) { // 1111, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hundert"+dblStrings[d3+d4]);
		}
		else if (d2 > 0 && d3 > 1 && d4 > 0) { // 1121, etc.
			return (oneStrings[d1]+"tausend"+oneStrings[d2]+"hundert"+oneStrings[d4]+"und"+tenStrings[d3]);
		}
	}
	else if (strLen == 5) {
		if (pNbr == 10000) {
			return "zehntausend";
		}
		else {
			alert ("Fr Zahlen ab 10001 ist das Script noch nicht ausgerstet.", "Achtung");
		}
	}
}